program QT3GPPFlatten;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  INIFiles,
  StrUtils,
  JEDI_QuickTime_Utils,
  qt_QuickDraw,
  qt_Files,
  qt_Movies,
  qt_MacTypes,
  qt_Script,
  qt_QuickTimeVR,
  C_Types,
  qt_QTML,
  qt_QDOffScreen,
  qt_Events,
  qt_Components,
  QTime,
  QTUtils,
  Classes;

const
  VERSION = '0.08';
  MovieExportType  =(((ord('s') shl 8 +ord('p'))shl 8 +ord('i'))shl 8 +ord('t')); {'spit'}
  FCC_TVOD         =(((ord('T') shl 8 +ord('V'))shl 8 +ord('O'))shl 8 +ord('D')); //FOUR_CHAR_CODE('TVOD')
  _3GPPFileType    =(((ord('3') shl 8 +ord('g'))shl 8 +ord('p'))shl 8 +ord('p')); {'3gpp'}

var
  DialogType: Longword;
  ContainItem  : TStringList;

function MovieExportDoUserDialog(ci:ComponentInstance; theMovie:Movie; onlyThisTrack:Track; startTime:TimeValue; duration:TimeValue; var canceled:Boolean):OSErr; cdecl; external 'qtmlClient.dll';
function MovieExportGetSettingsAsAtomContainer(ci:ComponentInstance; var settings:QTAtomContainer): OSErr; cdecl; external 'qtmlClient.dll';
function MovieExportSetSettingsFromAtomContainer(ci:ComponentInstance; settings:QTAtomContainer): OSErr; cdecl; external 'qtmlClient.dll';


// ---------------------------------------------------------
//   atom̃t@Cւ̏
// ---------------------------------------------------------

procedure WriteAllAtom(INI: TINIFile; Cont: QTAtomContainer; Parent: QTAtom; DirPos: String);
var
  myErr         : OSErr;
  currentatm,atm: QTAtom;
  atomType      : QTAtomType;
  id            : QTAtomID;
  atomData      : Ptr;
  size          : longint;
  s0,s1,s2      : String;
  flg           : Boolean;
  i,j           : Integer;
  p             : PChar;
begin
  currentatm := 0;
  flg := True;
  i := 0;
  while flg do
  begin
    myErr := QTNextChildAnyType( Cont, Parent, currentatm, atm);

    if (MyErr = noErr) then
    begin
      if (atm = 0) then
      begin
        flg := False;
      end
        else
      begin
        // atm̏擾
        QTGetAtomTypeAndID( Cont, atm, @atomType, id );
        QTGetAtomDataPtr( Cont, atm, size, atomData);
        s0 := DirPos+':'+IntToStr(i);
        s1 := chr((atomType shr 24) and $FF) + chr((atomType shr 16) and $FF) + chr((atomType shr 8) and $FF) + chr(atomType and $FF);
        s2 := '';
        p := Pointer(atomData);
        for j := 0 to size-1 do
        begin
          s2 := s2 + IntToHex(ord(p[j]),2);
        end;

        // ȅXV
        INI.WriteInteger(DirPos,'childs',i+1);
        // q̏
        INI.WriteString (s0,'atom',s1);
        INI.WriteInteger(s0,'id'  ,id);
        INI.WriteInteger(s0,'size',size);
        INI.WriteString (s0,'data',s2);

        // q
        WriteAllAtom(INI,Cont,atm,s0);
        // 
        currentatm := atm;
      end;
    end
      else
    begin
      flg := False;
    end;
    i := i + 1;
  end;
end;

// ---------------------------------------------------------
//   atom̃t@C̓ǂݍ
// ---------------------------------------------------------

procedure ReadAllAtom(INI: TINIFile; Cont: QTAtomContainer; Parent: QTAtom; DirPos: String);
var
  i,j,n   : Integer;
  atom,dat: String;
  id,siz  : Integer;
  p       : PChar;
  atype   : QTAtomType;
  newatm  : QTAtom;
begin
  atom := INI.ReadString(DirPos,'atom','');
  if (atom <> '') then
  begin
    // atomǉ
    id   := INI.ReadInteger(DirPos,'id'  ,1);
    siz  := INI.ReadInteger(DirPos,'size',0);
    dat  := INI.ReadString (DirPos,'data','');
    p := nil;
    if (siz <> 0) then GetMem(p, siz);
    for j := 0 to siz-1 do
    begin
      p[j] := Char(StrToIntDef('$'+Copy(dat,j*2+1,2),0));
    end;
    atype := (((ord(atom[1]) shl 8 +ord(atom[2]))shl 8 +ord(atom[3]))shl 8 +ord(atom[4]));
    QTInsertChild(Cont,Parent,atype,id,0,siz,Pointer(p),@newatm);
    Parent := newatm;
    if (p <> nil) then FreeMem(p);
  end;

  // q
  n := INI.ReadInteger(DirPos,'childs',0);
  for i := 0 to n-1 do
  begin
    ReadAllAtom(INI,Cont,Parent,DirPos+':'+IntToStr(i));
  end;
end;

// ---------------------------------------------------------
//   gExport TypeXgAbv
// ---------------------------------------------------------

function DWORD2FourCC(dat:Longword):String;
begin
  Result := Chr((dat shr 24) and $FF)+Chr((dat shr 16) and $FF)+Chr((dat shr 8) and $FF)+Chr(dat and $FF);
end;

procedure QT3GPP_ListType;
var
  looking,found  :ComponentDescription;
  foundComponent :Component;
begin
  InitializeQTML(0);      //Initialize QTML
  EnterMovies;            //Initialize QuickTime
  try
    looking.componentType         := MovieExportType;
    looking.componentSubType      := 0;
    looking.componentManufacturer := 0;
    looking.componentFlags        := 0;
    looking.componentFlagsMask    := 0;
    foundComponent                := NIL;
    foundComponent := FindNextComponent( foundComponent, looking);
    while (foundComponent <> NIL) do
    begin
      GetComponentInfo(foundComponent,found,NIL,NIL,NIL);
      write(DWORD2FourCC(found.componentSubType)+' ');
      foundComponent := FindNextComponent( foundComponent, looking);
    end;
  finally
    ExitMovies;           //Terminate QuickTime
    TerminateQTML;        //Terminate QTML
  end;
end;

// ---------------------------------------------------------
//   ԃVvConvertMovieToFile
// ---------------------------------------------------------

function QT3GPP_SimpleConvertMovieToFile(inFile: String):Integer;
var
  mov   :Movie;
  er    :OSErr;
  mRes  :short;
  ResID :short;
  fs    :FSSpec;
  outfs :FSSpec;
  MName :ShortString;
  chg   :Boolean;
begin
  Result := 0;
  InitializeQTML(0);      //Initialize QTML
  EnterMovies;            //Initialize QuickTime
  try
    // Open Movie
    mov := nil;
    NativePathNameToFSSpec(PChar(inFile),fs,0);
    NativePathNameToFSSpec(PChar(inFile),outfs,0);
    er  := OpenMovieFile(fs, mRes, ResID);
    if (er <> noErr) then
    begin
      writeln('A>ConvertMovieToFile:OpenMovieFile Error');
      Result := er; exit;
    end;
    ResID := 0;
    er  := NewMovieFromFile(mov, mRes, @ResID, @MName, newMovieActive, @chg);
    CloseMovieFile(mRes);
    if (er <> noErr) then
    begin
      writeln('A>ConvertMovieToFile:NewMovieFromFile Error');
      Result := er; exit;
    end;

    // ConvertMovie
    if (mov<>nil) then
    begin
      mRes := 0;
      er := ConvertMovieToFile(mov,nil,outfs,0,FCC_TVOD,smSystemScript,mRes,
              createMovieFileDeleteCurFile or showUserSettingsDialog or movieFileSpecValid or movieToFileOnlyExport,
              nil);
      if (er <> noErr) then
      begin
        writeln('A>ConvertMovieToFile:ConvertMovieToFile Error');
        Result := er; exit;
      end;
    end;
  finally
    ExitMovies;           //Terminate QuickTime
    TerminateQTML;        //Terminate QTML
  end;
end;



// ---------------------------------------------------------
//   ݒ
// ---------------------------------------------------------

function QT3GPP_ConvertMovieToFile(inFile: String; outFile: String; iniFile: String):Integer;
var
  mov   :Movie;
  er    :OSErr;
  mRes  :short;
  ResID :short;
  fs    :FSSpec;
  outfs :FSSpec;
  MName :ShortString;
  flg   :Boolean;

  exp   :ComponentInstance;
  acon  :QTAtomContainer;
  INI   :TINIFile;
  Dlgf  :Boolean;
  Savf  :Boolean;
begin
  Result := 0;
  InitializeQTML(0);      //Initialize QTML
  EnterMovies;            //Initialize QuickTime
  exp := nil;
  try
    // Open Movie
    mov := nil;
    NativePathNameToFSSpec(PChar(inFile),fs,0);
    er  := OpenMovieFile(fs, mRes, ResID);
    if (er <> noErr) then
    begin
      writeln('A>ConvertMovieToFile:OpenMovieFile Error');
      Result := er; exit;
    end;
    ResID := 0;
    er  := NewMovieFromFile(mov, mRes, @ResID, @MName, newMovieActive, @flg);
    CloseMovieFile(mRes);
    if (er <> noErr) then
    begin
      writeln('A>ConvertMovieToFile:NewMovieFromFile Error');
      Result := er; exit;
    end;

    // ConvertMovie
    if (mov<>nil) then
    begin
      // Check INi File
      Dlgf := True;
      if (iniFile <> '') then
      begin
        INI := TINIFile.Create(iniFile);
        try
          if (INI.ReadInteger('0','childs',-1)<0) then
            Dlgf := True
          else
            Dlgf := False;
        finally
          INI.Free;
        end;
      end;

      // Configurate Exporter
      exp := OpenDefaultComponent(MovieExportType,DialogType);
      if (exp = nil) then
      begin
        writeln('A>ConvertMovieToFile:OpenDefaultComponent Error');
        Result := -1; exit;
      end;
      Savf := False;
      if (Dlgf) then
      begin
        // _CAO̕\
        MovieExportDoUserDialog(exp,mov,nil,0,0,flg);
        if (flg) then
        begin
          writeln('A>ConvertMovieToFile:User cancelled');
          Result := -2; exit;
        end;
        Savf := True;
      end
        else
      begin
        // INIt@C̓ǂݍ
        INI := TINIFile.Create(iniFile);
        try
          QTNewAtomContainer(acon);
          ReadAllAtom(INI,acon,kParentAtomIsContainer,'0');
          MovieExportSetSettingsFromAtomContainer(exp, acon);
          QTDisposeAtomContainer(acon);
        finally
          INI.Free;
        end;
      end;

      // Save INI File
      if (Savf) and (iniFile<>'') then
      begin
        INI := TINIFile.Create(iniFile);
        try
          QTNewAtomContainer(acon);
          MovieExportGetSettingsAsAtomContainer(exp, acon);
          WriteAllAtom(INI,acon,kParentAtomIsContainer,'0');
          QTDisposeAtomContainer(acon);
        finally
          INI.Free;
        end;
      end;

      // Do Conversion
      mRes := 0;
      SetMovieActive(mov, True);
      NativePathNameToFSSpec(PChar(outFile),outfs,0);
      er := ConvertMovieToFile(mov,nil,outfs,0,FCC_TVOD,smSystemScript,mRes,
              createMovieFileDeleteCurFile, exp);
      if (er <> noErr) then
      begin
        writeln('A>ConvertMovieToFile:ConvertMovieToFile Error');
        Result := er; exit;
      end;
    end;
  finally
    if (exp <> nil) then CloseComponent(exp);
    ExitMovies;           //Terminate QuickTime
    TerminateQTML;        //Terminate QTML
  end;
end;



// ---------------------------------------------------------
//   Flatten
// ---------------------------------------------------------

function QT3GPP_Flatten(inFile: String; outFile: String):Integer;
var
  mov   :Movie;
  er    :OSErr;
  mRes  :short;
  ResID :short;
  fs    :FSSpec;
  outfs :FSSpec;
  MName :ShortString;
  chg   :Boolean;
begin
  Result := 0;
  InitializeQTML(0);      //Initialize QTML
  EnterMovies;            //Initialize QuickTime
  try
    // Open Movie
    mov := nil;
    NativePathNameToFSSpec(PChar(inFile),fs,0);
    NativePathNameToFSSpec(PChar(outFile),outfs,0);
    er  := OpenMovieFile(fs, mRes, ResID);
    if (er <> noErr) then
    begin
      writeln('A>QT3GPP_Flatten:OpenMovieFile Error');
      Result := er; exit;
    end;
    ResID := 0;
    er  := NewMovieFromFile(mov, mRes, @ResID, @MName, newMovieActive, @chg);
    CloseMovieFile(mRes);
    if (er <> noErr) then
    begin
      writeln('A>QT3GPP_Flatten:NewMovieFromFile Error');
      Result := er; exit;
    end;

    // FlattenMovie
    if (mov<>nil) then
    begin
      mRes := 0;
      FlattenMovieData(mov,flattenAddMovieToDataFork or flattenForceMovieResourceBeforeMovieData
                          ,outfs,FCC_TVOD,smSystemScript,createMovieFileDeleteCurFile);
      er := GetMoviesError();
      if (er <> noErr) then
      begin
        writeln('A>QT3GPP_Flatten:FlattenMovie Error');
        Result := er; exit;
      end;
    end;
  finally
    ExitMovies;           //Terminate QuickTime
    TerminateQTML;        //Terminate QTML
  end;
end;



// ---------------------------------------------------------
//   e|t@C̐
// ---------------------------------------------------------

function GetTempName: String;
var
  s: String;
  i: Integer;
begin
  s := '';
  for i:=0 to 3 do
  begin
    s := s + IntToHex(Random(65536),4)+IntToHex(Random(65536),4);
    if (i<>3) then s := s + '-';
  end;
  result := s;
end;


// ---------------------------------------------------------
//   CreationTime̓ǂݏo
// ---------------------------------------------------------
function ScanCreationTime(iFH:Integer; max:Int64; creationTime:Longword):Longint;
var
  start_ptr: Int64;
  ptr,size:  Int64;
  ch: array [0..3] of Byte;
  atom: String;
  contain,exec: Boolean;
  buf: Pointer;
begin
  start_ptr := FileSeek(iFH,0,1);
  ptr       := 0;

  while(ptr < max) do
  begin
    FileRead(iFH,ch,4);
    size := ch[0] * $1000000 + ch[1] * $10000 + ch[2] * $100 + ch[3];

    // ----- size=0 ُ ... atomI
    if (size<8) then
    begin
      FileSeek(iFH,start_ptr+max,0);
      ptr := max;
    end
      else
    begin
      FileRead(iFH,ch,4);
      atom := Chr(ch[0])+Chr(ch[1])+Chr(ch[2])+Chr(ch[3]);

      // ----- Atom`FbN
      contain  := (ContainItem.IndexOf(atom) >= 0);

      // ----- 
      if (contain) and (size>=16) then
      begin
        creationTime := ScanCreationTime(iFH,size-8,creationTime);
      end
        else
      begin
        exec := False;

        if (atom = 'mvhd') then
        begin
          GetMem(buf,size-8+1);
          try
            FileRead(iFH,PChar(buf)[0],size-8);
            exec := True;
            creationTime := ord(PChar(buf)[4]) * $1000000 + ord(PChar(buf)[5]) * $10000 +
                            ord(PChar(buf)[6]) *     $100 + ord(PChar(buf)[7]);
          finally
            FreeMem(buf);
          end;
        end;

        // ------ ȊOXLbv
        if (not exec) then FileSeek(iFH,size-8,1);
      end;
      ptr := FileSeek(iFH,0,1) - start_ptr;
    end;

  end;

  Result := creationTime;
end;

// ---------------------------------------------------------
//   CreationTimȅ
// ---------------------------------------------------------
procedure WriteCreationTime(iFH:Integer; max:Int64; creationTime:Longword);
var
  start_ptr: Int64;
  ptr,size:  Int64;
  ch: array [0..3] of Byte;
  atom: String;
  contain,exec: Boolean;
  buf: Pointer;
begin
  start_ptr := FileSeek(iFH,0,1);
  ptr       := 0;

  while(ptr < max) do
  begin
    FileRead(iFH,ch,4);
    size := ch[0] * $1000000 + ch[1] * $10000 + ch[2] * $100 + ch[3];

    // ----- size=0 ُ ... atomI
    if (size<8) then
    begin
      FileSeek(iFH,start_ptr+max,0);
      ptr := max;
    end
      else
    begin
      FileRead(iFH,ch,4);
      atom := Chr(ch[0])+Chr(ch[1])+Chr(ch[2])+Chr(ch[3]);

      // ----- Atom`FbN
      contain  := (ContainItem.IndexOf(atom) >= 0);

      // ----- 
      if (contain) and (size>=16) then
      begin
        WriteCreationTime(iFH,size-8,creationTime);
      end
        else
      begin
        exec := False;

        if (atom = 'mvhd') or (atom = 'tkhd') or (atom = 'mdhd') then
        begin
          GetMem(buf,size-8+1);
          try
            FileRead(iFH,PChar(buf)[0],size-8);
            exec := True;

            // creationTime
            PChar(buf)[ 4] := chr((creationTime div $1000000) and $FF);
            PChar(buf)[ 5] := chr((creationTime div   $10000) and $FF);
            PChar(buf)[ 6] := chr((creationTime div     $100) and $FF);
            PChar(buf)[ 7] := chr( creationTime               and $FF);
            // ModificationTime
            PChar(buf)[ 8] := chr((creationTime div $1000000) and $FF);
            PChar(buf)[ 9] := chr((creationTime div   $10000) and $FF);
            PChar(buf)[10] := chr((creationTime div     $100) and $FF);
            PChar(buf)[11] := chr( creationTime               and $FF);

            FileSeek(iFH,-(size-8),1);
            FileWrite(iFH,PChar(buf)[0],size-8);
          finally
            FreeMem(buf);
          end;
        end;

        // ------ ȊOXLbv
        if (not exec) then FileSeek(iFH,size-8,1);
      end;
      ptr := FileSeek(iFH,0,1) - start_ptr;
    end;

  end;
end;



// ---------------------------------------------------------
//   C[`
// ---------------------------------------------------------

var
  EXEName                      : String;
  APPName                      : String;
  optUsage                     : Boolean;
  optIniFile                   : Boolean;
  inputFile,outputFile,iniFile : String;
  trueOutput                   : String;
  needRename                   : Boolean;
  onlyFlatten                  : Boolean;
  creationTime                 : Longword;
  FH         : Integer;
  max        : Int64;
  i,r        : Integer;
  s,s1,s2,s3 : String;
begin
  Randomize;

  // R}hC
  EXEName := '';
  if (ParamCount >= 0) then EXEName := ParamStr(0);
  APPName := ChangeFileExt(ExtractFileName(EXEName),'');

  // Opening
  writeln(APPName+' for 3GP_Converter Version '+VERSION);
  writeln('http://www.nurs.or.jp/~calcium/');


  // l
  optUsage     := False;
  optIniFile   := False;
  needRename   := False;
  onlyFlatten  := False;
  inputFile    := '';
  outputFile   := '';
  trueOutput   := '';
  iniFile      := '';
  DialogType   := _3GPPFileType;
  creationTime := 0;

  // ReiƂȂAtom
  ContainItem := TStringList.Create;
  ContainItem.Add('moov');
  ContainItem.Add('trak');
  ContainItem.Add('edts');
  ContainItem.Add('mdia');
  ContainItem.Add('minf');
  ContainItem.Add('dinf');
  ContainItem.Add('stbl');
  ContainItem.Add('mvex');
  ContainItem.Add('moof');
  ContainItem.Add('traf');
  ContainItem.Add('mfra');
  ContainItem.Add('skip');
  ContainItem.Add('udta');
  ContainItem.Add('drm ');

  // 
  i := 1;
  while (i<=ParamCount) do
  begin
    s := ParamStr(i);
    i := i + 1;
    if (Copy(s,1,1)='-') then
    begin
      // Option
      s := UpperCase(Copy(s,2,Length(s)));
      if (s = 'C') then
      begin
        // IniFile
        if (i<=ParamCount) then
        begin
          iniFile := ParamStr(i);
          i := i + 1;
          optIniFile := True;
        end
          else
        begin
          optUsage := True;
        end;
      end
        else
      begin
        if (s = 'T') then
        begin
          if (i<=ParamCount) then
          begin
            s := ParamStr(i);
            i := i + 1;
            if (Length(s)>4) then
            begin
              optUsage := True;
            end
              else
            begin
              s := Copy(s+'    ',1,4);
              DialogType := (((ord(s[1]) shl 8 +ord(s[2]))shl 8 +ord(s[3]))shl 8 +ord(s[4]));
            end;
          end
        end
          else
        begin
          if (s = 'F') then
          begin
            onlyFlatten := True;
          end
            else
          begin
            // Error
            optUsage := True;
          end;
        end;
      end;
    end
      else
    begin
      // fileName
      if (inputFile = '') then
      begin
        inputFile := s;
      end
        else
      begin
        if (outputFile = '') then
        begin
          outputFile := s;
        end
          else
        begin
          // Error
          optUsage := True;
        end;
      end;
    end;
  end;
  if (inputFile = '') then optUsage := True;


  // 
  if (optUsage) then
  begin
    writeln('');
    writeln('Usage:');
    writeln(APPName + ' [inFile]');
    writeln('  inFileǂݍ݁AۑƏe_CAOŎw肵ۑ܂');
    writeln('');
    writeln(APPName + ' [inFile] [outFile]');
    writeln('  inFileǂݍ݁Ae_CAOŎw肵outFileɕۑ܂');
    writeln('');
    writeln(APPName + ' [inFile] [outFile] -f');
    writeln('  inFileǂݍ݁AoutFileɕۑ܂');
    writeln('');
    writeln(APPName + ' [inFile] [outFile] -c [iniFile] -t [type]');
    writeln('  inFileǂݍ݁AiniFileɏ]outFileɕۑ܂');
    writeln('  iniFileȂꍇ͏ew肷_CAO\A');
    writeln('  ݒeiniFileɕۑ܂B');
    writeln('  typew肵ꍇ͏e_CAO̎ʂύXł܂B');
    writeln('');
    writeln('[type]̈ꗗF');
    QT3GPP_ListType;
    writeln('');
    halt(1);
  end;

  if (outputFile = '') then
  begin
    r := QT3GPP_SimpleConvertMovieToFile(inputFile);
  end
    else
  begin
    // outputFilẻH
    // e|ȃt@Cɂ
    s1 := ExtractFilePath(outputFile);
    if (s1<>'') then s1 := IncludeTrailingPathDelimiter(s1);
    s2 := GetTempName;
    s3 := ExtractFileExt(outputFile);
    trueOutput := outputFile;
    outputFile := s1 + s2 + s3;
    needRename := True;

    if (onlyFlatten) then
    begin
      r := QT3GPP_Flatten(inputFile,outputFile);
    end
      else
    begin
      if (not optIniFile) then
      begin
        r := QT3GPP_ConvertMovieToFile(inputFile,outputFile,'');
      end
        else
      begin
        if (Copy(iniFile,2,1)<>':') and (Copy(iniFile,1,1)<>'\') then
          iniFile := ExpandFileName(IncludeTrailingPathDelimiter(ExtractFilePath(EXEName))+iniFile);
        r := QT3GPP_ConvertMovieToFile(inputFile,outputFile,iniFile);
      end;
    end;

    // inFileoutFileCreationTimeRs[
    FH := FileOpen(inputFile, fmOpenRead);
    if (FH>=0) then
    begin
      max := FileSeek(FH,0,2);
      FileSeek(FH,0,0);
      creationTime := ScanCreationTime(FH,max,0);
      FileClose(FH);
    end;
    if (creationTime <> 0) then
    begin
      FH := FileOpen(outputFile, fmOpenReadWrite);
      if (FH>=0) then
      begin
        max := FileSeek(FH,0,2);
        FileSeek(FH,0,0);
        WriteCreationTime(FH,max,creationTime);
        FileClose(FH);
      end;
    end;
  end;

  if (needRename) then
  begin
    if FileExists(trueOutput) then DeleteFile(trueOutput);
    RenameFile(outputFile,trueOutput);
  end;

  halt(r);
end.
